unit FillArrays;

interface
uses DateSyst,Syst;
const
epsilon = 0.00000000000001;  // 
N1 = 10; //     
N2 = 20; //       
N3 = 5;  //          

  function isLinear1( fun: TFunc2;ix: integer ): BVector;//         ix
  function isLinear2(fun:TFunc2;ix1,ix2,iy: integer):byte;//    iy    ix1  ix2
  procedure fill_arrays( fun1: TFunc1;fun:TFunc2);overload;
  procedure fill_arrays();overload;

var
p:B2Vector;
q:B3Vector;
x:DVector; //  
len:integer; //       
n_lin:integer;//   
equs,vars:IVector;
//     p,q    
// vars[0..] -  
// equs [0..] -  
implementation
//-------------------------------------------------------------------------
function isLinear1( fun: TFunc2; ix: integer ): BVector;
// 0,   f[iy]    x[ix]
// 1,   f[iy]   x[ix]
// 2,    f[iy]  x[ix] > 1.
//       
{      

   |y   x   1|
   |y1  x1  1| = 0;  y(x1-x2)-x(y1-y2)+(y1*x2-y2*x1)=0
   |y2  x2  1|

obl-    
}
var
  y1,y2,y3,z:DVector;
  i,j,k,n_var,n_equ:integer;
  res:BVector;
  obl:StatDVector;
  x1,x2:extended;
begin
  randomize;
  n_var:=f.Get_r;
  n_equ:=f.Get_s;
  SetLength(y1,n_equ);
  SetLength(y2,n_equ);
  SetLength(y3,n_equ);
  SetLength(res,n_equ);
  SetLength(z,n_equ);
  for i:=0 to n_equ-1 do res[i]:=1;
  for j:=1 to N1 do
  begin
    for i:=0 to n_equ-1 do z[i]:=0;
    for i:=0 to n_var-1 do                                         //
    begin                                                          //
      obl:=f.GetObl(i);                                            //       
      x[i]:=obl[1]-random*(obl[1]-obl[0]);                         //
      while (x[i]>=obl[1]) do x[i]:=obl[1]-random*(obl[1]-obl[0]); //
    end;                                                           //
    fun(x);
    y1:=copy(f.GetSys);  //       
    x1:=x[ix];          //      ix
    obl:=f.GetObl(ix);
    x[ix]:=obl[1]-random*(obl[1]-obl[0]);
    while ((x[ix]>=obl[1])and(x[ix]<>x1)) do x[ix]:=obl[1]-random*(obl[1]-obl[0]);//       ix
    fun(x);
    y2:=copy(f.GetSys);  //       
    x2:=x[ix];           //      ix
    for k:=1 to N2-2 do
    begin
      x[ix]:=obl[1]-random*(obl[1]-obl[0]);
      while (x[ix]>=obl[1]) do x[ix]:=obl[1]-random*(obl[1]-obl[0]); //       ix
      fun(x);
      y3:=copy(f.GetSys);  //       
      for i:=0 to n_equ-1 do if (abs(x[ix]*(y1[i]-y2[i])-y3[i]*(x1-x2) + (x1*y2[i]-y1[i]*x2))>=epsilon) then res[i]:=2;   //          
      for i:=0 to n_equ-1 do z[i]:=z[i]+(y1[i]-y2[i]); //   z   
      x1:=x2;             //
      x2:=x[ix];          // 
      y1:=copy(y2);       //   
      y2:=copy(f.GetSys); //
    end;
    for i:=0 to n_equ-1 do if  (abs(z[i])=0) then res[i]:=0; //               
  end;
  result:=res;

end;
//--------------------------------------------------------------------
function  isLinear2(fun:TFunc2;ix1,ix2,iy: integer):byte;
// 0,   f[iy]   x[ix1]   x[ix2]
// 1,   f[iy]    x[ix1]   x[ix2]
{      

   |y   x   xx   1|                       =a                                            =b
   |y1  x1  xx1  1| = 0;  y(x2*xx3+x3*xx1+x1*xx2-x3*xx2-x1*xx3-x2*xx1)-x(y1*xx2+y2*xx3+y3*xx1-y1*xx3-y2*xx1-y3*xx2)+
   |y2  x2  xx2  1|                     =c                                             =d
   |y3  x3  xx3  1|         +xx(y1*x2+y2*x3+y3*x1-y1*x3-y2*x1-y3*x2)-(y1*x2*xx3+y2*x3*xx1+y3*x1*xx2-y1*x3*xx2-y2*x1*xx3-y3*x2*xx1)


obl1,obl2 -    

       isLinear1     
     .
a,b,c,d   
}
var
y1,y2,y3,x1,x2,x3,xx1,xx2,xx3,a,b,c,d,z:extended;
res:byte;
i,j:integer;
obl1,obl2:StatDVector;
begin
  res:=1;
  for i:=0 to (f.Get_r-1) do
  begin
    obl1:=f.GetObl(i);
    x[i]:=obl1[1]-random*(obl1[1]-obl1[0]);
    while (x[i]>=obl1[1]) do x[i]:=obl1[1]-random*(obl1[1]-obl1[0]);
  end;
  fun(x);
  y1:=f.GetFun(iy);
  x1:=x[ix1];
  xx1:=x[ix2];
  obl1:=f.GetObl(ix1);
  obl2:=f.GetObl(ix2);
  x[ix1]:=obl1[1]-random*(obl1[1]-obl1[0]);
  while (x[ix1]>=obl1[1]) do x[ix1]:=obl1[1]-random*(obl1[1]-obl1[0]);
  x[ix2]:=obl2[1]-random*(obl2[1]-obl2[0]);
  while (x[ix2]>=obl2[1]) do x[ix2]:=obl2[1]-random*(obl2[1]-obl2[0]);
  fun(x);
  y2:=f.GetFun(iy);
  x2:=x[ix1];
  xx2:=x[ix2];
  x[ix1]:=obl1[1]-random*(obl1[1]-obl1[0]);
  while (x[ix1]>=obl1[1]) do x[ix1]:=obl1[1]-random*(obl1[1]-obl1[0]);
  x[ix2]:=obl2[1]-random*(obl2[1]-obl2[0]);
  while (x[ix2]>=obl2[1]) do x[ix2]:=obl2[1]-random*(obl2[1]-obl2[0]);
  fun(x);
  y3:=f.GetFun(iy);
  x3:=x[ix1];
  xx3:=x[ix2];
  for j:=1 to N3-3 do
  begin
    d:=y1*x2*xx3+y2*x3*xx1+y3*x1*xx2-y1*x3*xx2-y2*x1*xx3-y3*x2*xx1;
    a:=x2*xx3+x3*xx1+x1*xx2-x3*xx2-x1*xx3-x2*xx1;
    b:=y1*xx2+y2*xx3+y3*xx1-y1*xx3-y2*xx1-y3*xx2;
    c:=y1*x2+y2*x3+y3*x1-y1*x3-y2*x1-y3*x2;
    x[ix1]:=obl1[1]-random*(obl1[1]-obl1[0]);
    while (x[ix1]>=obl1[1]) do x[ix1]:=obl1[1]-random*(obl1[1]-obl1[0]);
    x[ix2]:=obl2[1]-random*(obl2[1]-obl2[0]);
    while (x[ix2]>=obl2[1]) do x[ix2]:=obl2[1]-random*(obl2[1]-obl2[0]);
    fun(x);
    z:= abs(a*f.GetFun(iy)-b*x[ix1]+c*x[ix2]-d);
    if (z>epsilon) then begin res:=0; break; end;
    y1:=y2;
    y2:=y3;
    y3:=f.GetFun(iy);
    x1:=x2;
    x2:=x3;
    x3:=x[ix1];
    xx1:=xx2;
    xx2:=xx3;
    xx3:=x[ix2];
  end;
  result:=res;
end;
//-------------------------------------------------------------------
procedure fill_arrays();
//     p,q    
var
i,j,k:integer;
v,u:IVector;
flag:boolean;
{ ,    v[0], ... v[t-1]   
 u[0], ..., u[t-1]    :

    1) p[ u[i], v[j] ] < 2       0<=i<t, 0<=j=t,
    2) q[ u[i], v[j], [k] ] = 0  0<=i<t, 0<=j<t, 0<=k<t

 ,    v[0], ... v[t-1]    
      u[0], ..., u[t-1] 
  :

    3)     t*t- p[ u[i], v[j] ]   0
    4)        t*t- p[ u[i], v[j] ]   0

         :

     k<t  k      k 
     (    )

 k=1        (3)  (4).}
begin
  n_lin:=0;
  SetLength(v,len);
  SetLength(u,len);
  for i:=0 to len-1 do u[i]:=i; //      (  u[0]<u[1]<...<u[len-1])   len
  repeat
    for i:=0 to len-1 do v[i]:=i; //      (  v[0]<v[1]<...<v[len-1])   len
    repeat
      //----------------------------------------------------------------------
      flag:=true;                                                                                  //
      for  i:=0 to len-1 do                                                                        //
        for j:=0 to len-1 do if (p[ u[i], v[j] ] > 1) then flag:=false;                            //
      for  k:=0 to len-1 do                                                                        //
        for i:=0 to len-1 do                                                                       //
          for j:=i+1 to len-1 do if (q[ u[k], v[i], v[j] ] = 0) then flag:=false;                  //
      for  i:=0 to len-1 do                                                                        //  1),2),3),4)
      begin                                                                                        //    
        k:=0;                                                                                      // u  v
        for j:=0 to len-1 do k:=k+p[ u[i], v[j] ];                                                 //
        if ((flag)and(k=0)) then flag:=false;                                                      //
      end;                                                                                         //
      for  i:=0 to len-1 do                                                                        //
      begin                                                                                        //
        k:=0;                                                                                      //
        for j:=0 to len-1 do k:=k+p[ u[j], v[i] ];                                                 //
        if ((flag)and(k=0)) then flag:=false;                                                      //
      end;                                                                                         //
      if (flag) then                                                                               //
      begin                                                                                        //
        n_lin:=n_lin+1;                                                                            //
        SetLength(equs,n_lin*len);                                                                 //
        SetLength(vars,n_lin*len);                                                                 //
        for i:=0 to len-1 do begin equs[(n_lin-1)*len+i]:=u[i]; vars[(n_lin-1)*len+i]:=v[i]; end;  //
      end;
      //-----------------------------------------------------------------------
      j:=len-1;
      v[j]:=(v[j]+1) mod f.Get_r;
      while (v[j]=0)and(j>0) do
      begin
        j:=j-1;
        v[j]:=(v[j]+1) mod (f.Get_r-(len-1-j))
      end;
      for i:=j+1 to len-1 do v[i]:=v[i-1]+1;
    until  (v[len-1]=len-1);
    j:=len-1;
    u[j]:=(u[j]+1) mod f.Get_s;
    while (u[j]=0)and(j>0) do
    begin
      j:=j-1;
      u[j]:=(u[j]+1) mod (f.Get_s-(len-1-j))
    end;
    for i:=j+1 to len-1 do u[i]:=u[i-1]+1;
  until  (u[len-1]=len-1);
  if (n_lin = 0)and(len>0) then begin  len:=len-1; fill_arrays(); end; //     len    len     
  if (len = 0) then begin err:='Linear subsystems not found';exit; end; //        
end;
//--------------------------------------------------------------------
procedure fill_arrays( fun1: TFunc1;fun:TFunc2);
//   p,q    f
var
p_:BVector;
i,j,k:integer;
begin
  fun1;//  
  SetLength(x,f.Get_r);
  SetLength(p,f.Get_s,f.Get_r);
  SetLength(q,f.Get_s,f.Get_r,f.Get_r);
  SetLength(p_,f.Get_s);
  for j:=0 to (f.Get_r-1) do
  begin
    p_:=isLinear1(fun,j);
    for i:=0 to (f.Get_s-1) do p[i,j]:=p_[i];
  end;
  for k:=0 to f.Get_s-1 do
    for i:=0 to f.Get_r-1 do
      for j:=i+1 to f.Get_r-1 do if ((p[k,i]<>1)or(p[k,j]<>1)) then q[k,i,j]:=0 else q[k,i,j]:=isLinear2(fun,i,j,k);
  if (f.Get_s<f.Get_r) then len:=f.Get_s else len:=f.Get_r;//  len   
  fill_arrays();
end;
//--------------------------------------------------------------------------
end.
